import Text.Printf

type GoID = Int
type Dt   = Float

data GameObject = GameObject
    { goID   :: GoID
    , render :: IO ()
    , update :: Float -> GameObject }

banana :: GoID -> GameObject
banana goid =
    GameObject
    { goID   = goid
    , render = printf "banana: id %d\n" goid
    , update = const $ banana goid }

type Level   = Int
type Elapsed = Float

apple :: Level -> Elapsed -> GoID -> GameObject
apple level elapsed goid =
    GameObject
    { goID   = goid
    , render = printf "apple: id %d, level %d\n" goid level
    , update = \dt ->
        let elapsed' = elapsed + dt
        in if elapsed' >= 5.0
            then apple (level+1) (elapsed' - 5.0) goid
            else apple  level     elapsed'        goid }